import rospy
from clover import srv
from std_srvs.srv import Trigger

rospy.init_node('flight')

get_telemetry = rospy.ServiceProxy('get_telemetry', srv.GetTelemetry)
navigate = rospy.ServiceProxy('navigate', srv.Navigate)
navigate_global = rospy.ServiceProxy('navigate_global', srv.NavigateGlobal)
set_position = rospy.ServiceProxy('set_position', srv.SetPosition)
set_velocity = rospy.ServiceProxy('set_velocity', srv.SetVelocity)
set_attitude = rospy.ServiceProxy('set_attitude', srv.SetAttitude)
set_rates = rospy.ServiceProxy('set_rates', srv.SetRates)
land = rospy.ServiceProxy('land', Trigger)

import math

def navigate_wait(x=0, y=0, z=0, yaw=float('nan'), speed=0.5, frame_id='', auto_arm=False, tolerance=0.2):
        navigate(x=x, y=y, z=z, yaw=yaw, speed=speed, frame_id=frame_id, auto_arm=auto_arm)

        while not rospy.is_shutdown():
                telem = get_telemetry(frame_id='navigate_target')
                if math.sqrt(telem.x ** 2 + telem.y ** 2 + telem.z ** 2) < tolerance:
                        break
                rospy.sleep(0.2)
                print ("wait")

navigate_wait(z = 1, frame_id = 'body', auto_arm = True)

navigate_wait(z = 1, frame_id = 'aruco_38')
x = 0
print ("loop")

while x < 2:
        print ("1")
        navigate_wait(z = 1, frame_id = 'aruco_31')
        print ("2")
        navigate_wait(z = 1, frame_id = 'aruco_21')
        print ("3")
        navigate_wait(z = 1, frame_id = 'aruco_14')
        print ("4")
        navigate_wait(z = 1, frame_id = 'aruco_19')
        print ("5")
        navigate_wait(z = 1, frame_id = 'aruco_33')
        print ("6")
        navigate_wait(z = 1, frame_id = 'aruco_38')
        x = x+1
land()
